From cffeab3e96c2beabdc24d436e04fa883c851866f Mon Sep 17 00:00:00 2001
From: Jana Librova <jcupova@redhat.com>
Date: Sep 04 2024 07:17:14 +0000
Subject: [PATCH 9/11] Fix review


---

diff --git a/plugins/builder/taskrepos.py b/plugins/builder/taskrepos.py
index d425fc5..a1c7b1a 100644
--- a/plugins/builder/taskrepos.py
+++ b/plugins/builder/taskrepos.py
@@ -89,22 +89,20 @@ class TaskReposTask(BaseTaskHandler):
 
     def build_arches(self, rpms):
         arches = set()
-        for rpm in rpms:
-            if isinstance(rpm, str):
-                rpm = koji.parse_NVRA(os.path.basename(rpm))
-            if rpm['arch'] == 'src':
+        for rpm, arch in rpms:
+            if arch == 'src':
                 continue
-            arches.add(rpm['arch'])
+            if arch not in arches:
+                arches.add(arch)
         return arches
 
     def create_pkg_list(self, rpms, repodir):
         remote_pi = koji.PathInfo(topdir='')
         dest_dirs = []
         pkglist = []
-        for rpm in rpms:
+        for rpm, arch in rpms:
             url = joinpath(remote_pi.work(), rpm)
             url = f'toplink{url}'
-            arch = rpm.split('.')[-2]
             dest = joinpath(repodir, arch)
             if dest not in dest_dirs:
                 dest_dirs.append(dest)
@@ -127,30 +125,27 @@ class TaskReposTask(BaseTaskHandler):
                 repotype = 'scratch'
         info = None
         rpms = []
-        results = {
-            'rpms': [],
-            'srpms': [],
-        }
+        srpms = []
+        results = []
         for taskinfo in tasksinfo:
             task_result = self.session.getTaskResult(taskinfo['id'])
-            results['rpms'].extend(task_result['rpms'])
-            results['srpms'].extend(task_result['srpms'])
-        if results['srpms'] != []:
-            srpm = results['srpms'][0]
-            srpmname = os.path.basename(results['srpms'][0])
-            info = koji.parse_NVRA(srpmname)
-        if info is None:
-            raise koji.GenericError("SRPM is missing.")
-        if results['rpms'] != []:
-            rpms.extend(results['rpms'])
+            for tr_rpm in task_result['rpms']:
+                results.append([tr_rpm, taskinfo['arch']])
+            if task_result['srpms'] != []:
+                srpms.extend([task_result['srpms'][0], taskinfo['arch']])
+                srpmname = os.path.basename(task_result['srpms'][0])
+                info = koji.parse_NVRA(srpmname)
+            if info is None:
+                raise koji.GenericError("SRPM is missing.")
+            if results != []:
+                rpms.extend(results)
         repodir = joinpath(self.workdir, info['name'], info['version'], info['release'])
         repodir_nvr = joinpath(repotype, info['name'], info['version'], info['release'])
         nvr = '%s-%s-%s' % (info['name'], info['version'], info['release'])
 
         koji.ensuredir(repodir)
-
         self.create_pkg_list(rpms, repodir)
-        rpms.append(srpm)
+        rpms.append(srpms)
         for arch in self.build_arches(rpms):
             self.gen_repodata(joinpath(repodir, arch))
         for arch in self.build_arches(rpms):
diff --git a/plugins/hub/taskrepos_hub.py b/plugins/hub/taskrepos_hub.py
index 6a4ded0..3c3bfe8 100644
--- a/plugins/hub/taskrepos_hub.py
+++ b/plugins/hub/taskrepos_hub.py
@@ -18,20 +18,6 @@ __all__ = ('taskrepos', 'taskRepoNotifications', 'taskRepoDone')
 logger = logging.getLogger('koji.hub')
 
 
-def recursive_walk(dirpath, repo_urls, topurl, task_link):
-    for root, dir, files in os.walk(dirpath):
-        if dir:
-            for subfolder in dir:
-                recursive_walk(subfolder, repo_urls, topurl, task_link)
-        if task_link:
-            folder_name_part = root[root.find('repos-tasks'):]
-        else:
-            folder_name_part = root[root.find('tasks'):]
-        for filename in files:
-            repo_urls.append(joinpath(topurl, folder_name_part, filename))
-    return repo_urls
-
-
 @export_in('host')
 def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
     repo_urls = []
@@ -46,6 +32,7 @@ def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
         if not os.path.exists(src):
             raise koji.GenericError("uploaded file missing: %s" % src)
         safer_move(src, taskfile)
+        repo_urls.append(taskfile)
 
     if task_link:
         task_dir_with_id = joinpath(
@@ -59,12 +46,18 @@ def taskRepoDone(task_id, repos, repodir_nvr, topurl, task_link):
             rmtree(reponvr_dir)
         os.symlink(task_dir_with_id, reponvr_dir)
 
+    for i in range(0, len(repo_urls) - 1):
+        if task_link:
+            repo_urls[i] = repo_urls[i].replace(
+                joinpath(koji.pathinfo.topdir, 'repos-tasks', 'tasks', str(task_id % 10000),
+                         str(task_id)), reponvr_dir)
+        repo_urls[i] = repo_urls[i].replace(koji.pathinfo.topdir, topurl)
+
     if task_link:
         files_dir = reponvr_dir
     else:
         files_dir = joinpath(
             koji.pathinfo.topdir, 'repos-tasks', 'tasks', str(task_id % 10000), str(task_id))
-    repo_urls = recursive_walk(files_dir, repo_urls, topurl, task_link)
 
     koji.util.rmtree(joinpath(
         koji.pathinfo.work(), '/'.join(rp.split(str(task_id))[:1]), str(task_id)))

